#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire500one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire500one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one5004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


                                    
# -------------------------------------------------------------------------------------------------
# 500
# -------------------------------------------------------------------------------------------------                                          
shot2one5004xi = {
                  1:'0x0y499z',
                  2:'0x10y499z',
                  3:'0x15y499z',
                  4:'0x20y499z',
                  5:'0x331y374z',
                  6:'0x450y217z',
                  7:'0x5y499z',
                  8:'0x64y495z',
                  9:'106x349y341z',
                  10:'108x283y396z',
                  11:'109x445y199z',
                  12:'10x28y499z',
                  13:'10x33y498z',
                  14:'111x388y294z',
                  15:'112x423y240z',
                  16:'122x274y399z',
                  17:'123x340y344z',
                  18:'130x379y298z',
                  19:'132x436y204z',
                  20:'134x263y402z',
                  21:'134x415y244z',
                  22:'13x381y322z',
                  23:'140x330y348z',
                  24:'145x252y405z',
                  25:'149x369y302z',
                  26:'14x0y499z',
                  27:'14x465y181z',
                  28:'154x405y248z',
                  29:'154x427y208z',
                  30:'155x319y351z',
                  31:'156x241y408z',
                  32:'15x12y499z',
                  33:'166x229y411z',
                  34:'166x358y306z',
                  35:'170x307y355z',
                  36:'174x394y253z',
                  37:'175x416y213z',
                  38:'176x217y414z',
                  39:'17x326y378z',
                  40:'183x346y310z',
                  41:'184x204y417z',
                  42:'184x295y358z',
                  43:'18x16y499z',
                  44:'191x191y419z',
                  45:'194x382y257z',
                  46:'195x405y217z',
                  47:'197x282y362z',
                  48:'198x178y422z',
                  49:'200x333y313z',
                  50:'204x165y425z',
                  51:'209x152y427z',
                  52:'209x268y365z',
                  53:'212x369y261z',
                  54:'215x320y317z',
                  55:'215x392y222z',
                  56:'221x254y369z',
                  57:'22x447y222z',
                  58:'230x305y321z',
                  59:'230x355y265z',
                  60:'231x239y372z',
                  61:'234x378y226z',
                  62:'241x224y375z',
                  63:'243x290y325z',
                  64:'246x340y270z',
                  65:'249x209y379z',
                  66:'253x363y231z',
                  67:'256x275y329z',
                  68:'257x193y382z',
                  69:'25x24y598z',
                  70:'262x325y274z',
                  71:'263x178y385z',
                  72:'268x259y333z',
                  73:'270x348y235z',
                  74:'277x309y278z',
                  75:'278x242y336z',
                  76:'286x331y240z',
                  77:'288x225y340z',
                  78:'28x414y277z',
                  79:'291x292y282z',
                  80:'297x208y344z',
                  81:'2x4y499z',
                  82:'2x59y496z',
                  83:'301x314y244z',
                  84:'303x274y286z',
                  85:'315x256y290z',
                  86:'316x296y248z',
                  87:'326x237y294z',
                  88:'329x278y253z',
                  89:'33x321y381z',
                  90:'33x377y326z',
                  91:'341x259y257z',
                  92:'38x462y185z',
                  93:'45x443y226z',
                  94:'4x0y499z',
                  95:'4x54y496z',
                  96:'50x315y384z',
                  97:'50x409y281z',
                  98:'52x372y329z',
                  99:'5x8y499z',
                  100:'62x458y190z',
                  101:'65x308y387z',
                  102:'68x437y231z',
                  103:'71x365y333z',
                  104:'71x403y286z',
                  105:'7x13y499z',
                  106:'7x418y273z',
                  107:'7x49y497z',
                  108:'80x301y390z',
                  109:'86x452y195z',
                  110:'89x358y337z',
                  111:'8x17y499z',
                  112:'8x44y497z',
                  113:'91x396y290z',
                  114:'91x431y235z',
                  115:'95x292y393z',
                  116:'9x0y499z',
                  117:'9x22y499z',
                  118:'9x38y498z'}
                  

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire500one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire500one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE50ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE50ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE50ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE50ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE50ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE5004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one5004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE50ONE4XI - SUCCEEDED TO PUT SHOT2ONE5004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE5004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE50ONE4XI *** FAILED TO PUT SHOT2ONE5004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE50ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one5004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one5004xi</nack2put4xi>" 
                    
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
 
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE50ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one5004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE50ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE50ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire500one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
